# Contributing to `grpc-tools`

There are many ways to contribute and help the development of these tools. 

## Using the tools and providing feedback

One of the easiest (but most valuable) ways to contribute to this project is to simply use `grpc-dump`, `grpc-fixture`, etc. as tools and 

### Voting on existing feature requests

As always, there are more improvements that could be made to these tools than there is time to implement these features.

Voting for [issues](https://github.com/bradleyjkemp/grpc-tools/issues) using a :+1: reaction will help prioritise development of features that people want the most.

Some issues (with the "[design question](https://github.com/bradleyjkemp/grpc-tools/issues?q=is%3Aissue+is%3Aopen+label%3A%22design+question%22)" label) are more open ended and so feedback is appreciated on any proposed solutions.

### Making feature requests

If you think there's a feature missing that we could add to these tools, please create an issue describing:
* What problem you're trying to solve.
* What the feature you're proposing is.
* How the feature would solve your problem.

### Reporting bugs

When reporting bugs please try to provide as much detail as necessary for us to reproduce your issue.

Ideally a runnable go program or something like a `curl` command that demonstrates the problem.

## Submitting pull requests

The tools in this repository are still in early stages of development and so the code is not yet very friendly to newcomers.

There are a few issues with the "[good first issue](https://github.com/bradleyjkemp/grpc-tools/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22)" label which should be well defined and small in scope and so a good introduction to the codebase.

For the more adventurous, any issue with the "[ready for development](https://github.com/bradleyjkemp/grpc-tools/issues?q=is%3Aissue+is%3Aopen+label%3A%22ready+for+development%22)" label is ready to be implemented though the exact details may not have been worked out yet.

In any case, it's a good idea to add a comment to any issue you plan on working on so that we can give guidance where necessary and avoid duplicated work.


[//]: # (TODO: add a getting started guide for setup, testing, etc.)
